# BLIND SQL INJECTION CHARMAP   -   www.ush.it
# Written by Francesco `ascii` Ongaro based on
# Stefano `Wisec` Di Paola's bisection method.
# Mail me at ascii AT ush DOT it for comments.

# To be loaded into your MySQL db.
# php news.sql.php > news.sql && mysql -u root -p < news.sql

DROP DATABASE IF EXISTS `blindnews`;

# Damn. http://bugs.mysql.com/bug.php?id=19166
GRANT USAGE ON *.* TO 'blindnews'@'localhost';
DROP USER 'blindnews'@'localhost';

CREATE DATABASE `blindnews`;

CREATE USER 'blindnews'@'localhost' IDENTIFIED BY 'CHANGE_ON_INSTALL';

GRANT USAGE ON *.* TO 'blindnews'@'localhost' IDENTIFIED BY 'CHANGE_ON_INSTALL' WITH 
MAX_QUERIES_PER_HOUR 0 MAX_CONNECTIONS_PER_HOUR 0 MAX_UPDATES_PER_HOUR 0 MAX_USER_CONNECTIONS 0 ;

GRANT SELECT, INSERT, UPDATE, DELETE ON `blindnews`.* TO 'blindnews'@'localhost';

USE `blindnews`;

CREATE TABLE `users` (
`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY COMMENT 'User ID',
`name` VARCHAR( 50 ) NOT NULL COMMENT 'User name',
`password` VARCHAR( 50 ) NOT NULL COMMENT 'User password',
`creditcard` VARCHAR( 16 ) NOT NULL COMMENT 'User CC'
) ENGINE = MYISAM ;

INSERT INTO `users` ( `id` , `name` , `password` , `creditcard` )
VALUES (
 NULL , 'Unlucky User', SHA1( 'easy' ) , '1234123412341234'
), (
 NULL , 'Rich user', SHA1( 'very hard password?' ) , '4321432143214321'
);

CREATE TABLE `news_data` (
`id` MEDIUMINT NOT NULL AUTO_INCREMENT PRIMARY KEY COMMENT 'News ID',
#`seo_id` VARCHAR( 50 ) NOT NULL COMMENT 'News seo ID',
`seo_id` MEDIUMINT NOT NULL COMMENT 'News seo ID',
`body` TEXT NOT NULL COMMENT 'News body'
) ENGINE = MYISAM COMMENT = 'News table';

<?php

error_reporting(E_ALL);

$created = 0;
$id = 0;

$alpha = 'QWERTYUIOP';

while($created < 500) {
 $rand = rand(0,3);

 if ($rand < 3) {

  // Let's simulate some collisions
  $title = '';
  for ($i=0;$i<3;$i++) $title .= $alpha[rand(0,strlen($alpha)-1)];
  // echo 'INSERT INTO `news_data` (`id`, `seo_id`, `body`) VALUES (NULL , \'news_'.$id.'\', \'News '.$title.'\');'."\n";
  echo 'INSERT INTO `news_data` (`id`, `seo_id`, `body`) VALUES (NULL , '.($id+1).', \'News '.$title.'\');'."\n";

  $id++;
  $created++;

 } else {

  // And some deletions (some ids could be unexistant but who cares)
  echo 'DELETE FROM `news_data` WHERE `id` = '.rand(0, $id).' LIMIT 1;'."\n";

  $created--;

 }

}

?>
